"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCLiteralNode subclass:#PPCInlineLiteralNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Nodes'
!

!PPCInlineLiteralNode methodsFor:'compiling'!

compileWith: compiler effect: effect id: id
	| encodedLiteral |
	
	encodedLiteral := self encodeQuotes: literal.
	compiler startInline: id.
	compiler add: '((context peek: ', literal size asString, ') = #''', encodedLiteral, ''')'.
	compiler indent.
	compiler add: ' ifTrue: [ context skip: ', literal size asString, '. #''', encodedLiteral, ''']'.
	compiler add: ' ifFalse: [ self error: ''', encodedLiteral,  ' expected'' ].'.
	compiler dedent.
 ^ compiler stopInline.
! !

!PPCInlineLiteralNode methodsFor:'printing'!

asInlined
	^ self
!

printOn: aStream
	aStream nextPutAll: '#inline'.
	super printOn: aStream
! !

