"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCStarNode subclass:#PPCStarAnyNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Nodes'
!

!PPCStarAnyNode methodsFor:'as yet unclassified'!

compileWith: compiler effect: effect id: id
	compiler startMethod: id.
	compiler addVariable: 'retval size'.
	compiler add: 'size := context size - context position.'.
	compiler add: 'retval := Array new: size.'.
	compiler add: '(1 to: size) do: [ :e | retval at: e put: context next ].'.
	compiler add: '^ retval'.
 ^ compiler stopMethod.
!

prefix
	^ #starAny
!

rewrite: changeStatus
	"Nothing TODO"
! !

